import { useState, useEffect, useRef, useCallback } from 'react';
/**
 * React hook for combine the state of a value prop and its default value
 **/

var useControlledState = function useControlledState(controlledValue, defaultValue) {
  var isFirst = useRef(true);

  var _useState = useState(controlledValue === undefined ? defaultValue : controlledValue),
      initialValue = _useState[0];

  var _useState2 = useState(initialValue),
      value = _useState2[0],
      setValue = _useState2[1];

  useEffect(function () {
    if (isFirst.current) {
      isFirst.current = false;
    } else {
      setValue(controlledValue);
    }
  }, [controlledValue, setValue, isFirst]);
  var updater = useCallback(function (value, forceFlag) {
    if (controlledValue === undefined || forceFlag) {
      setValue(value);
    }
  }, [controlledValue, setValue]);
  return [value, updater, controlledValue !== undefined, initialValue];
};

export default useControlledState;